# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .credential_filter_data import CredentialFilterData
from .credential_filter_kind import CredentialFilterKind
from .filter_annotations import FilterAnnotations
from .filter_id import FilterId
from .filter_integer import FilterInteger
from .filter_labels import FilterLabels
from .filter_string import FilterString
from .filter_timestamp import FilterTimestamp
from .filter_timestamp_optional import FilterTimestampOptional

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class CredentialFilter(pydantic.BaseModel):
    """
    Schema for the CredentialResource filter.
    """

    annotations: typing.Optional[FilterAnnotations] = None
    created_at: typing.Optional[FilterTimestamp] = None
    data: typing.Optional[CredentialFilterData] = None
    deleted_at: typing.Optional[FilterTimestampOptional] = None
    etag: typing.Optional[FilterString] = None
    id: typing.Optional[FilterId] = None
    kind: typing.Optional[CredentialFilterKind] = None
    labels: typing.Optional[FilterLabels] = None
    modified_at: typing.Optional[FilterTimestamp] = None
    revision: typing.Optional[FilterInteger] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
